_G["TaskArchive"] = class(AITask, function(c)
	AITask.init(c)	-- must init base!
	c.Id = _G["TASK_ARCHIVE"]
	c.TargetRoom = TVT.ROOM_ARCHIVE_PLAYER_ME
	c.BudgetWeight = 0
	c.BasePriority = 2
	c.NeededInvestmentBudget = 0
	c.InvestmentPriority = 0

	c.latestSaleOnDay = -1	
	c.emergencySale = false --todo: festlegen wann/ob der Notfall ist
end)

function TaskArchive:typename()
	return "TaskArchive"
end

function TaskArchive:Activate()
	self.SellMoviesJob = JobSellMovies()
	self.SellMoviesJob.Task = self
end

function TaskArchive:GetNextJobInTargetRoom()
	--nur einmal am Tag verkaufen, ausser im Notfall
	if self.latestSaleOnDay >= WorldTime.GetDay() and not self.emergencySale
	then
		debugMsg(timetostring().." archive Task, been here done that")
	elseif (self.SellMoviesJob.Status ~= JOB_STATUS_DONE) then
		debugMsg("return SellMoviesJob")
		return self.SellMoviesJob
	end
	
	self.emergencySale = false
	self:SetWait()
end


-- <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


_G["JobSellMovies"] = class(AIJob, function(c)
	AIJob.init(c)	-- must init base!
	c.Task = nil
	c.FreshnessTreshold = 1.0	--change to sell movies with more/less Topicalty should be 0.8, changed for debug
	c.emergencyFreshnessTreshold = 1
	
end)

function JobSellMovies:typename()
	return "JobSellMovies"
end

function JobSellMovies:Prepare(pParams)

end


function JobSellMovies:Tick()
	function newarchivedMovie (a,b,c,d,e,f)
		local t = 
		{
			Title = "N/A";
			GUID = "";
			Id = -1;
			Freshness = 1;
			planned = -1;
			price = 0;
		}
		t.Title = a
		t.GUID = b
		t.Id = c
		t.Freshness = d
		t.planned = e
		t.price = f
		return t;
	end

	debugMsg("archive: Sell movies job started")
	--ins archiv wenn nach mitternacht (oben)
	
	self.Task.latestSaleOnDay = WorldTime.GetDay()	
	
	--filmliste getten
	local nArchive = TVT.ar_GetProgrammeLicenceCount()
	debugMsg ("# archived licences: "..nArchive)
	local movies = {};
	for i=0, (nArchive-1)
	do
		m = TVT.convertToProgrammeLicence(TVT.ar_GetProgrammeLicence(i).data)
		--ignore episodes/collection-elements
		if m ~= nil and m.HasParentLicence()==0 then
			vm = newarchivedMovie(m.GetTitle(),m.GetGUID(), m.GetId(),(m.GetTopicality() / m.GetMaxTopicality()),m.isPlanned(),m.GetPrice(TVT.ME))
			debugMsg("# found "..vm.Title.." (guid="..vm.GUID.."  id="..vm.Id..") ".." "..vm.price..", "..(vm.Freshness*100).."%, planned: "..tostring(vm.planned))
			table.insert(movies,vm)
		end
	end
	debugMsg("# checking single/series licences: "..#movies)

	--Nach aktualität filtern, keine eingeplanten, im Notfall Schwelle fürs Behalten erhöhen, ganz teure immer behalten
	local treshold = self.FreshnessTreshold
	if self.Task.emergencySale then treshold = self.emergencyFreshnessTreshold end
	local case = {}
	for k,v in pairs (movies) 
	do
		if v == nil then debugMsg("# ERROR: movie #" .. k.." is nil") end
		if (v.Freshness < self.FreshnessTreshold) and (v.planned ==  0) and (v.price < 100000)
		then
			debugMsg("# mark for suitcase: "..v.Title)
			table.insert(case,v)
		end
	end
	
	debugMsg("# selected for suitcase: "..#case)

	--in koffer legen
	for i=1, #case
	do
		ec = TVT.ar_AddProgrammeLicenceToSuitcaseByGUID(case[i].GUID)
		if ec == 1 then
			debugMsg("# put "..case[i].Title.." in suitcase, OK")
		else
			debugMsg("# put "..case[i].Title.." in suitcase, errorcode: "..ec)
		end
	end	
	
	self.Status = JOB_STATUS_DONE	
	--leave archive klappt noch nicht
	--im md: verkaufen

	-- send figure to movie dealer now
	local player = _G["globalPlayer"]
	if player ~= nil then 
		local task = player.TaskList[_G["TASK_MOVIEDISTRIBUTOR"]]
		if task ~= nil then
			debugMsg("# increasing SituationPriority for movie distributor task")
			task.SituationPriority = 150 --arbitrary value, maybe needs higher one
		end
	end

	debugMsg("archive: Sell movies job done")
end

function timetostring()
	local t = ""
	t = "Day: "..WorldTime.GetDay()..", "..WorldTime.GetDayHour().." : "..WorldTime.GetDayMinute()
	return t
end
